//==============================================================
// OSK֘A
// STEAR 2009
//--------------------------------------------------------------
// UCS - VtgJISϊ̓I^vEŨ\[XQlɂĂ܂B
//--------------------------------------------------------------

#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspgu.h>
#include <string.h>
#include <psputility.h>
#include <psputility_osk.h>

#include "osk.h"
#include "cp932.h"

#define BUF_WIDTH	(512)
#define SCR_WIDTH	(480)
#define SCR_HEIGHT	(272)
#define MAXTEXT		128											// ̍ő

extern int	gExitRequest;										// [HOME]ɂI`FbNîmain.cŒ`j

static unsigned int *gList;

//==============================================================
// GU
//--------------------------------------------------------------
// OSKpGUZbgAbv܂B
//--------------------------------------------------------------

void oskSetupGu(unsigned int *list)
{
	sceGuInit();

	gList = list;
	sceGuStart(GU_DIRECT,list);
	sceGuDrawBuffer(GU_PSM_8888,(void*)0,BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH,SCR_HEIGHT,(void*)0x88000,BUF_WIDTH);
	sceGuDepthBuffer((void*)0x110000,BUF_WIDTH);
	sceGuOffset(2048 - (SCR_WIDTH/2),2048 - (SCR_HEIGHT/2));
	sceGuViewport(2048,2048,SCR_WIDTH,SCR_HEIGHT);
	sceGuDepthRange(0xc350,0x2710);
	sceGuScissor(0,0,SCR_WIDTH,SCR_HEIGHT);
	sceGuEnable(GU_SCISSOR_TEST);
	sceGuDepthFunc(GU_GEQUAL);
	sceGuEnable(GU_DEPTH_TEST);
	sceGuFrontFace(GU_CW);
	sceGuShadeModel(GU_FLAT);
	sceGuEnable(GU_CULL_FACE);
	sceGuEnable(GU_TEXTURE_2D);
	sceGuEnable(GU_CLIP_PLANES);
	sceGuFinish();
	sceGuSync(0,0);

	sceDisplayWaitVblankStart();
	sceGuDisplay(GU_TRUE);
}

//==============================================================
// VtgJISUCSϊ
//--------------------------------------------------------------
// str1 ϊUCSi[p
// str2 ƂȂVtgJISi'\0'j
//--------------------------------------------------------------

static void sjis2ucs(unsigned short *str1,char *str2)
{
	int	pos1,pos2,ucs,max;

	max = MAXTEXT;
	pos1 = 0;
	pos2 = 0;
	while (str2[pos2] && pos1<max){
		ucs = conv_sjiswin_wchar((unsigned char)str2[pos2++]);
		if (ucs==-1) continue;
		str1[pos1++] = ucs;
	}
	str1[pos1] = 0;
}

//==============================================================
// UCSVtgJISϊ
//--------------------------------------------------------------
// str1 ϊVtgJISi[p
// str2 ƂȂUCS
//--------------------------------------------------------------

static void ucs2sjis(char *str1,unsigned short *str2)
{
	int	pos1,pos2,sjis,max;

	max = MAXTEXT;
	pos1 = 0;
	pos2 = 0;
	while (str2[pos2]){
		sjis = conv_wchar_sjiswin(str2[pos2++]);
		if (sjis<0x100){
			str1[pos1++] = sjis;
		} else {
			if (pos1>=max-2) break;
			str1[pos1++] = sjis & 0xFF;
			str1[pos1++] = (sjis>>8) & 0xFF;
		}
		if (pos1>=max-1) break;
	}
	str1[pos1] = '\0';
}

//==============================================================
// OSK͏
//--------------------------------------------------------------
// title   ^Cg
// intext  OSKNɗ\ߓ͂Ă
// outtext OSK͂ꂽ
// ߂l  0:蔭/LZ ȊO:I
//--------------------------------------------------------------
// łGȔ͍sȂ̂ŁA\߃ZbgAbvĂƁB
// gExitRequestɂ钆f main.c ŃZbgAbvĂƁB
// ̓VtgJISœ/o͂܂B
//--------------------------------------------------------------

int oskInput(char *title,char *intext,char *outtext)
{
	int done = 0;
	unsigned short	oskIn[MAXTEXT],oskOut[MAXTEXT],oskDesc[128];

	outtext[0] = '\0';
	oskOut[0] = 0;
	sjis2ucs(oskIn,intext);
	sjis2ucs(oskDesc,title);

	PspOskData data;
	memset(&data, 0, sizeof(data));
	data.unk_00 = 1;
	data.unk_04 = 0;
	data.language = 0; // hiragana
	data.unk_12 = 0;
	data.unk_16 = 0;
	data.lines = MAXTEXT;										// s
	data.unk_24 = 0;
	data.desc = oskDesc;
	data.intext = oskIn;
	data.outtextlength = MAXTEXT;
	data.outtextlimit = MAXTEXT;
	data.outtext = oskOut;

	PspOsk osk;
	memset(&osk, 0, sizeof(osk));
	osk.size = sizeof(osk);
	osk.language = 0;
	osk.buttonswap = 0;
	osk.unk_12 = 17; // What
	osk.unk_16 = 19; // the
	osk.unk_20 = 18; // fuck
	osk.unk_24 = 16; // ???
	osk.unk_48 = 1;
	osk.data = &data;

	if(sceUtilityOskInitStart((SceUtilityOskParams*) &osk)) return 0;

	while(!done && !gExitRequest){
		sceGuStart(GU_DIRECT,gList);
		sceGuClearColor(0x666666);
		sceGuClearDepth(0);
		sceGuClear(GU_COLOR_BUFFER_BIT | GU_DEPTH_BUFFER_BIT);

		sceGuFinish();
		sceGuSync(0,0);

		switch(sceUtilityOskGetStatus()){
		case OSK_NONE:
			break;
		case OSK_INIT:
			break;
		case OSK_VISIBLE:
			sceUtilityOskUpdate(2); // 2 is taken from ps2dev.org recommendation
			break;
		case OSK_QUIT:
			sceUtilityOskShutdownStart();
			break;
		case OSK_FINISHED:
			done = 1;
			break;
		default:
			break;
		}

		sceDisplayWaitVblankStart();
		sceDisplayWaitVblankStart();							// ̂܂܂Ƒ̂Ńt[1/30
		sceGuSwapBuffers();
	}

	ucs2sjis(outtext,data.outtext);								// ͕VtgJIS֕ϊ

	return 1;
}

